
public class Entity {

  public float x, y;
  public float xa = 0;
  public float ya = 0;
  public float speed = 1;
  public float fric = 0.75;
  public int tex = 0;
  public int size = 1;
  public boolean removed = false;

  public void update() {
    x += xa;
    y += ya;

    for (Entity e : entities) {
      if (checkCollision(e)) collide(e);
    }

    xa *= fric;
    ya *= fric;

    if (abs(xa) < 0.0001) xa = 0;
    if (abs(ya) < 0.0001) ya = 0;
    image(sprites[tex], x, y);
    noTint();
  }

  public void collide(Entity entity) {
  }

  public boolean checkCollision(Entity e) {
    if (e != this) {
      for (int x1 = 0; x1 <= 1; x1++) {
        for (int y1 = 0; y1 <= 1; y1++) {
          if (x+size*x1 >= e.x && x+size*x1 <= e.x+e.size) {
            if (y+size*y1 >= e.y && y+size*y1 <= e.y+e.size) {
              return true;
            }
          }
        }
      }
    }
    return false;
  }

  public boolean inWindow() {
    if (x+size >= 0 && x < width/SCALE && y+size >= 0 && y < height/SCALE) {
      return true;
    }
    return false;
  }

  public void destroy() {
    entities.remove(this);
  }
}

